<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head>
		<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
		<meta http-equiv="X-UA-Compatible" content="IE=9"/>
		<meta name="generator" content="Doxygen 1.8.18"/>
		<meta name="viewport" content="width=device-width, initial-scale=1"/>
		<title>Sorting algorithms: Riferimenti per il file src/sorting_algorithms.cpp</title>
		<link href="tabs.css" rel="stylesheet" type="text/css"/>
		<script type="text/javascript" src="jquery.js"></script>
		<script type="text/javascript" src="dynsections.js"></script>
		<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
		<link href="doxygen.css" rel="stylesheet" type="text/css" />
		<link href="custom.css" rel="stylesheet" type="text/css"/>
<link href="custom_dark_theme.css" rel="stylesheet" type="text/css"/>
	</head>
	<body>
	<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
		<div id="titlearea">
			<table cellspacing="0" cellpadding="0">
				<tbody>
					<tr style="height: 56px;">
						<td id="projectalign" style="padding-left: 0.5em;">
							<div id="projectname">Sorting algorithms
							</div>
						</td>
					</tr>
				</tbody>
			</table>
		</div>
		<!-- end header part --><!-- Generato da Doxygen 1.8.18 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Cerca');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Cerca');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div id="nav-path" class="navpath">
  <ul>
<li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.html">src</a></li>  </ul>
</div>
</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#func-members">Funzioni</a>  </div>
  <div class="headertitle">
<div class="title">Riferimenti per il file sorting_algorithms.cpp</div>  </div>
</div><!--header-->
<div class="contents">
<div class="textblock"><code>#include &quot;../include/sorting_algorithms.h&quot;</code><br />
</div><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="func-members"></a>
Funzioni</h2></td></tr>
<tr class="memitem:a15ddf346bc3418b47965de88cf65d9f4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="sorting__algorithms_8cpp.html#a15ddf346bc3418b47965de88cf65d9f4">selectionSort</a> (int a[], int n)</td></tr>
<tr class="memdesc:a15ddf346bc3418b47965de88cf65d9f4"><td class="mdescLeft">&#160;</td><td class="mdescRight">algoritmo di ordinamento selection sort.  <a href="sorting__algorithms_8cpp.html#a15ddf346bc3418b47965de88cf65d9f4">Continua...</a><br /></td></tr>
<tr class="separator:a15ddf346bc3418b47965de88cf65d9f4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a984a82572b786dc675486f5d527115df"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="sorting__algorithms_8cpp.html#a984a82572b786dc675486f5d527115df">insertionSort</a> (int a[], int n)</td></tr>
<tr class="memdesc:a984a82572b786dc675486f5d527115df"><td class="mdescLeft">&#160;</td><td class="mdescRight">algoritmo di ordinamento insertion sort.  <a href="sorting__algorithms_8cpp.html#a984a82572b786dc675486f5d527115df">Continua...</a><br /></td></tr>
<tr class="separator:a984a82572b786dc675486f5d527115df"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba02a9d35a21534ff8b1836b497c4046"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="sorting__algorithms_8cpp.html#aba02a9d35a21534ff8b1836b497c4046">mergeSort</a> (int a[], int l, int r)</td></tr>
<tr class="memdesc:aba02a9d35a21534ff8b1836b497c4046"><td class="mdescLeft">&#160;</td><td class="mdescRight">algoritmo di ordinamento merge sort.  <a href="sorting__algorithms_8cpp.html#aba02a9d35a21534ff8b1836b497c4046">Continua...</a><br /></td></tr>
<tr class="separator:aba02a9d35a21534ff8b1836b497c4046"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a61761bbdde1e463d2bda0e14ba899f9d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="sorting__algorithms_8cpp.html#a61761bbdde1e463d2bda0e14ba899f9d">quickSort</a> (int arr[], int l, int h)</td></tr>
<tr class="memdesc:a61761bbdde1e463d2bda0e14ba899f9d"><td class="mdescLeft">&#160;</td><td class="mdescRight">algoritmo di ordinamento quick sort.  <a href="sorting__algorithms_8cpp.html#a61761bbdde1e463d2bda0e14ba899f9d">Continua...</a><br /></td></tr>
<tr class="separator:a61761bbdde1e463d2bda0e14ba899f9d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a397d8f2010f747a513584a1e9154bde0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="sorting__algorithms_8cpp.html#a397d8f2010f747a513584a1e9154bde0">countingSort</a> (int a[], int n)</td></tr>
<tr class="memdesc:a397d8f2010f747a513584a1e9154bde0"><td class="mdescLeft">&#160;</td><td class="mdescRight">algoritmo di ordinamento quick sort.  <a href="sorting__algorithms_8cpp.html#a397d8f2010f747a513584a1e9154bde0">Continua...</a><br /></td></tr>
<tr class="separator:a397d8f2010f747a513584a1e9154bde0"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<h2 class="groupheader">Documentazione delle funzioni</h2>
<a id="a397d8f2010f747a513584a1e9154bde0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a397d8f2010f747a513584a1e9154bde0">&#9670;&nbsp;</a></span>countingSort()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void countingSort </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>a</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>algoritmo di ordinamento quick sort. </p>
<p>1) trovo l'elemento più grande nell'array<br  />
2) inizializzo un array count contenente il numero di occorenze di ogni elemento<br  />
3) calcolo la somma accumulativa per ogni elemento<br  />
4) costruisco l'array ordinato, come indice il valore nell'array count - 1 e come valore il valore nell'array originario, in ordine inverso<br  />
5) copio l'array temporaneo in quello originale<br  />
<br  />
 costo computazionale:<br  />
 time: best: Ω(n + k), avg: θ(n + k) , worst: O(n + k)<br  />
 space: worst O(k)<br  />
<br  />
 notare che il costo computazionale dipende da k, ovvero l'elemento più grande dell'array</p>
<dl class="params"><dt>Parametri</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>array in input </td></tr>
    <tr><td class="paramname">n</td><td>lunghezza di a </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a984a82572b786dc675486f5d527115df"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a984a82572b786dc675486f5d527115df">&#9670;&nbsp;</a></span>insertionSort()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void insertionSort </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>a</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>algoritmo di ordinamento insertion sort. </p>
<p>1) si seleziona l'elemento (da a[1]) salvandolo in key<br  />
2) si setta un altro indice (j) per scorrere la lista indietro<br  />
3) si scorre indietro finchè non si è alla fine o si è trovato il posto giusto per key, shiftando ogni volta l'array a destra per fare posto a key<br  />
4) una volta trovato il posto giusto per key, lo si posiziona<br  />
5) si incrementa l'indice dell'elemento selezionato<br  />
6) si ripete da 1) fino a che non si è ciclano tutto l'array - 1<br  />
<br  />
 costo computazionale:<br  />
 time: best: Ω(n), avg: θ(n^2), worst: O(n^2)<br  />
 space: worst: O(1)</p>
<dl class="params"><dt>Parametri</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>array in input </td></tr>
    <tr><td class="paramname">n</td><td>lunghezza di a </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="aba02a9d35a21534ff8b1836b497c4046"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aba02a9d35a21534ff8b1836b497c4046">&#9670;&nbsp;</a></span>mergeSort()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void mergeSort </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>a</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>l</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>r</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>algoritmo di ordinamento merge sort. </p>
<p>1) si divide a metà finche non rimane solo un elemento (costo O(log(n)))<br  />
2) si uniscono gli elementi in ordine metà per metà, ricombinandoli il costo di ordinamento è O(n) visto che le metà sono già ordinate<br  />
<br  />
 chaiamta principale: mergeSort(a, 0, ARR_LEN - 1)<br  />
<br  />
 costo computazionale:<br  />
 time: best: Ω(n*log(n)), avg: θ(n*log(n)) , worst: O(n*log(n))<br  />
 space: worst O(n)</p>
<dl class="params"><dt>Parametri</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>array in input </td></tr>
    <tr><td class="paramname">l</td><td>indice primo elemento </td></tr>
    <tr><td class="paramname">r</td><td>indice ultimo elemento<br  />
<br  />
</td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a61761bbdde1e463d2bda0e14ba899f9d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a61761bbdde1e463d2bda0e14ba899f9d">&#9670;&nbsp;</a></span>quickSort()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void quickSort </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>arr</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>l</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>h</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>algoritmo di ordinamento quick sort. </p>
<p>1) uso l'ultimo elemento come pivot<br  />
2) attraverso partition, sposto tutti gli elementi minori del pivot a sinistra, e tutti i maggiori a destra<br  />
 3) ripeto ricorsivamente sulla metà a sinistra e sulla metà a destra<br  />
<br  />
 chaiamta principale: quickSort(a, 0, ARR_LEN - 1)<br  />
<br  />
 costo computazionale:<br  />
 time: best: Ω(n*log(n)), avg: θ(n*log(n)) , worst: O(n^2)<br  />
 space: worst O(log(n))</p>
<dl class="params"><dt>Parametri</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>array in input </td></tr>
    <tr><td class="paramname">l</td><td>indice primo elemento </td></tr>
    <tr><td class="paramname">h</td><td>indice ultimo elemento<br  />
<br  />
</td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a id="a15ddf346bc3418b47965de88cf65d9f4"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a15ddf346bc3418b47965de88cf65d9f4">&#9670;&nbsp;</a></span>selectionSort()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void selectionSort </td>
          <td>(</td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>a</em>[], </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>n</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>algoritmo di ordinamento selection sort. </p>
<p>1) si setta l'elemento selezioato (all'inizio a[0]) come minimo<br  />
2) si ciclano tutti gli elementi successivi in cerca di uno minore<br  />
3) si sostituisce l'elemento selezionato con il minimo<br  />
4) si incrementa l'indice dell'elemento selezionato<br  />
5) si ripete da 1) fino a che non si è ciclano tutto l'array - 1<br  />
<br  />
 costo computazionale:<br  />
 time: best: Ω(n^2), avg: θ(n^2) , worst: O(n^2)<br  />
 space: worst O(1)</p>
<dl class="params"><dt>Parametri</dt><dd>
  <table class="params">
    <tr><td class="paramname">a</td><td>array in input </td></tr>
    <tr><td class="paramname">n</td><td>lunghezza di a </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
</div><!-- contents -->
<!-- start footer part -->
		<script src="custom.js"></script>
	</body>
</html>